.nolist
include \masm32\include\masm32rt.inc
include \masm32\macros\ucmacros.asm
include \masm32\include\shlwapi.inc
includelib \masm32\lib\shlwapi.lib

.686
.xmm

.data
;
;   CPU architecture structure.
;
STRU_CPU_ARCH               STRUCT
                            wCPU_Arch               WORD ?
                            wReserved               WORD ?
STRU_CPU_ARCH               ENDS

;
;   System Info structure.
;
STRU_SYS_INFO               STRUCT
                                UNION               CPU_TYPE
                                    dOEMID          DWORD ?
                                    CPUArchiture    STRU_CPU_ARCH <>
                                ENDS
                            dPageSize               DWORD ?
                            pMinAppAddress          PDWORD ?
                            pMaxAppAddress          PDWORD ?
                            pActiveCPUMask          PDWORD ?
                            dNumberOfCPUS           DWORD ?
                            dCPUType                DWORD ?
                            dAllocationGramularity  DWORD ?
                            dProcessorLevel         WORD ?
                            dProcessorRevision      WORD ?
STRU_SYS_INFO               ENDS
.data?

    dVirtualBase    DWORD ?
    dSize           DWORD ?
    System_Info     STRU_SYS_INFO <>
    dPageSize       DWORD ?
    dSystemStatus   DWORD ?

.code
start:
;
;   Get system info
;
    INVOKE GetSystemInfo,OFFSET System_Info
    mov    eax,System_Info.dPageSize
    mov    dPageSize,eax
;
;   Calculate the space required modulo page size.
;
;
;   Reserve the space required.
;
    INVOKE VirtualAlloc,0,dPageSize,MEM_RESERVE,PAGE_NOACCESS
    mov    dVirtualBase,eax
    or     eax,eax
    jnz    Ok1
    int 3
Ok1:
;
;   Commit the space required.
;
    INVOKE VirtualAlloc,dVirtualBase,dPageSize,MEM_COMMIT,PAGE_READWRITE
    or     eax,eax
    jnz    Ok2
    int 3
Ok2:
GoodTest:
    mov    ebx,dVirtualBase                 ;   Get the buffer start.
    add    ebx,dPageSize                    ;   Get the buffer end.
    sub    ebx,7                            ;   Get the string start (6 NULLS and a NULL).
    mov         ecx,ebx                     ;   Save the string start.
    and         ebx,-16                     ;   Force mod 16 alignment.
    mov         edx,0FFFFh                  ;   Get full mask.
    pxor   xmm1,xmm1                        ;   16 nulls.
    movdqa xmm0,OWORD PTR [ebx]             ;   Get start of string.
    sub         ecx,ebx                     ;   Calculate leading garbage characters.
    pcmpeqb xmm0,xmm1                       ;   Calculate matches.
    shl         edx,cl                      ;   Correct the mask for the leading garbage.
    pmovmskb ecx,xmm0                       ;   Extract bitmap of matches.
    and         ecx,edx                     ;   Correct the bitmap for garbage the first time.
    mov         edx,0FFFFh                  ;   Force all remaining checks to be full checks.
;
;   ...
;
BadTest:
    mov    eax,dVirtualBase                 ;   Get the buffer start.
    add    eax,dPageSize                    ;   Get the buffer end.
    sub    eax,7                            ;   Get the string start (6 NULLS and a NULL).
    movdqu xmm0,OWORD PTR [eax]             ;   This will fail.
int 3
	exit
end start

